Package com.saxonica.ee.stream.adjunct

## Class ForEachGroupAdjunct

- java.lang.Object
- - com.saxonica.ee.stream.adjunct.StreamingAdjunct
  - - com.saxonica.ee.stream.adjunct.TransmissionAdjunct
    - - com.saxonica.ee.stream.adjunct.ForEachAdjunct
      - - com.saxonica.ee.stream.adjunct.ForEachGroupAdjunct

- All Implemented Interfaces:
    `FeedMaker`

      public class ForEachGroupAdjunct
      extends ForEachAdjunct

  Compile an xsl:for-each-group instruction to streaming code.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ForEachGroupAdjunct()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PostureAndSweep` | `computeStreamability​(ContextItemStaticInfoEE contextInfo, java.util.List<java.lang.String> reasons)` | Get the "sweep" of this expression as defined in the W3C streamability specifications.
    `WatchMaker` | `getWatchMaker​(boolean forGrouping)` | Get a WatchMaker, a factory class that creates a Watch to evaluate this expression in streaming mode.
    `static GroupBoundaryTester` | `makeBoundaryTester​(ForEachGroup instruction, XPathContext populationContext)` |
    `ItemFeed` | `makeItemFeed​(WatchManager watchManager, ItemFeed out, XPathContext context)` |

    - ### Methods inherited from class com.saxonica.ee.stream.adjunct.ForEachAdjunct

      `getActionInversion, getStreamability, setExpression, toStreamingPattern`

    - ### Methods inherited from class com.saxonica.ee.stream.adjunct.TransmissionAdjunct

      `makeTransmissionFlow`

    - ### Methods inherited from class com.saxonica.ee.stream.adjunct.StreamingAdjunct

      `findConsumingArg, getConfiguration, getDefaultFeedMaker, getExpression, getFeedMaker, makeStreamingAdjunct, setConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ForEachGroupAdjunct

          public ForEachGroupAdjunct()

  - ### Method Detail

    - #### computeStreamability

          public PostureAndSweep computeStreamability​(ContextItemStaticInfoEE contextInfo,
                                                      java.util.List<java.lang.String> reasons)

      Get the "sweep" of this expression as defined in the W3C streamability specifications. This provides an assessment of stylesheet code against the W3C criteria for guaranteed streamability, and is implemented to allow these criteria to be tested. It is not the case that all expression that emerge as streamable from this analysis are currently capable of being streamed by Saxon
      Overrides:
        `computeStreamability` in class `ForEachAdjunct`
      Parameters:
        `contextInfo` - whatever is known statically about the context item
        `reasons` - return parameter to hold reasons for non-streamability @return the posture and sweep
      Returns:
        the posture and sweep of the expression

    - #### getWatchMaker

          public WatchMaker getWatchMaker​(boolean forGrouping)
                                   throws XPathException

      Description copied from class: `StreamingAdjunct`
      Get a WatchMaker, a factory class that creates a Watch to evaluate this expression in streaming mode. This method will only be called if the getImplementationMethod() method of the expression includes the value `Expression.WATCH_METHOD`
      Overrides:
        `getWatchMaker` in class `ForEachAdjunct`
      Parameters:
        `forGrouping` - true if the selected items are being grouped
      Returns:
        a Watchmaker to evaluate the expression, or null if it is not streamable with respect to the specificed argument.
      Throws:
        `XPathException` - in the event of a failure

    - #### makeItemFeed

          public ItemFeed makeItemFeed​(WatchManager watchManager,
                                       ItemFeed out,
                                       XPathContext context)
                                throws XPathException

      Specified by:
        `makeItemFeed` in interface `FeedMaker`
      Overrides:
        `makeItemFeed` in class `ForEachAdjunct`
      Throws:
        `XPathException`

    - #### makeBoundaryTester

          public static GroupBoundaryTester makeBoundaryTester​(ForEachGroup instruction,
                                                               XPathContext populationContext)